{-----------------------------------------------------------------------------}
{-                                                                           -}
{-   Projet : RPNCALC                                                        -}
{-   Module : RPNFORM -- User interface stuff                                -}
{-                                                                           -}
{-   Version : 0.9 (September 11, 1995)                                      -}
{-                                                                           -}
{-   Written by Cyrille Chplov <100420.1574@compuserve.com>                -}
{-   Graphics by Pierre Chplov                                             -}
{-                                                                           -}
{-  These source files and the associated executable are freeware.           -}
{-  Constructive feedback is greatly encouraged !                            -}
{-                                                                           -}
{-  Warranty : none. Use at your own risk.                                   -}
{-                                                                           -}
{-----------------------------------------------------------------------------}

unit Rpnform;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, ShellAPI, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, ExtCtrls,RpnEngine, Tabs, Buttons, IniFiles;

type
  TRPN_Form = class(TForm)
    Panel1: TPanel;
    Panel3: TPanel;
    StkDisp: TListBox;
    Panel4: TPanel;
    Entry: TEdit;
    Panel5: TPanel;
    Panel6: TPanel;
    Panel8: TPanel;
    ListBox1: TListBox;
    Tabs: TTabSet;
    Book: TNotebook;
    _deg: TRadioButton;
    _Rad: TRadioButton;
    _Grad: TRadioButton;
    _2nd: TSpeedButton;
    _COS: TSpeedButton;
    _SIN: TSpeedButton;
    _TAN: TSpeedButton;
    _INV: TSpeedButton;
    _SINH: TSpeedButton;
    _COSH: TSpeedButton;
    _TANH: TSpeedButton;
    _SQx: TSpeedButton;
    _SQRT: TSpeedButton;
    _YexpX: TSpeedButton;
    SpeedButton8: TSpeedButton;
    _LOG: TSpeedButton;
    _LN: TSpeedButton;
    _EXP: TSpeedButton;
    _E10: TSpeedButton;
    _FACT: TSpeedButton;
    _Comb: TSpeedButton;
    _Arr: TSpeedButton;
    _PI: TSpeedButton;
    Panel2: TPanel;
    Pick: TSpeedButton;
    Button3: TSpeedButton;
    _7: TSpeedButton;
    _8: TSpeedButton;
    _9: TSpeedButton;
    _6: TSpeedButton;
    _5: TSpeedButton;
    _4: TSpeedButton;
    _1: TSpeedButton;
    _2: TSpeedButton;
    _3: TSpeedButton;
    _0: TSpeedButton;
    _div: TSpeedButton;
    _mul: TSpeedButton;
    _sub: TSpeedButton;
    _dot: TSpeedButton;
    _spc: TSpeedButton;
    _add: TSpeedButton;
    _C: TSpeedButton;
    _neg: TSpeedButton;
    _swp: TSpeedButton;
    _eex: TSpeedButton;
    _clear: TSpeedButton;
    _drop: TSpeedButton;
    _Enter: TBitBtn;
    UnFold: TSpeedButton;
    Fold: TSpeedButton;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure _EnterClick(Sender: TObject);
    procedure _NumClick(Sender: TObject);
    procedure _CClick(Sender: TObject);
    procedure _addClick(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure _subClick(Sender: TObject);
    procedure _mulClick(Sender: TObject);
    procedure _divClick(Sender: TObject);
    procedure _negClick(Sender: TObject);
    procedure _eexClick(Sender: TObject);
    procedure _spcClick(Sender: TObject);
    procedure _dropClick(Sender: TObject);
    procedure _negMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure _clearClick(Sender: TObject);
    procedure _swpClick(Sender: TObject);
    procedure ListBox1DragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure ListBox1DragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure TabsChange(Sender: TObject; NewTab: Integer;
      var AllowChange: Boolean);
    procedure _2ndClick(Sender: TObject);
    procedure _degClick(Sender: TObject);
    procedure _RadClick(Sender: TObject);
    procedure _GradClick(Sender: TObject);
    procedure _SINClick(Sender: TObject);
    procedure _COSClick(Sender: TObject);
    procedure _TANClick(Sender: TObject);
    procedure _TANHClick(Sender: TObject);
    procedure _COSHClick(Sender: TObject);
    procedure _SINHClick(Sender: TObject);
    procedure _PIClick(Sender: TObject);
    procedure _SQxClick(Sender: TObject);
    procedure _YexpXClick(Sender: TObject);
    procedure _EXPClick(Sender: TObject);
    procedure _E10Click(Sender: TObject);
    procedure _SQRTClick(Sender: TObject);
    procedure SpeedButton8Click(Sender: TObject);
    procedure _LNClick(Sender: TObject);
    procedure _LOGClick(Sender: TObject);
    procedure _FACTClick(Sender: TObject);
    procedure _CombClick(Sender: TObject);
    procedure _ArrClick(Sender: TObject);
    procedure FoldClick(Sender: TObject);
    procedure UnFoldClick(Sender: TObject);
    procedure ListBox1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Button3Click(Sender: TObject);
    procedure PickClick(Sender: TObject);
  private
    { Private-dclarations }
  protected
    UnFolded : Boolean;
    Ini : TIniFile;

    Procedure RefreshFolded;
  public
    { Public-dclarations }

    Stack : TRPNStack;
    Procedure RefreshView;

    Procedure SimKey(down : boolean; key : word);
  public
    { mthodes de calcul et routines annexes }

    Function ProcessEntry : boolean;
    Procedure MessageEvent(var msg : TMSG; var Handled : boolean);
  end;

var
  RPN_Form: TRPN_Form;

implementation

Const
     KState = 'State'; { section du .INI }
       KUnFolded = 'UnFolded';
       KLeft = 'Left';
       KTop = 'Top';
       KMinimized = 'Minimized';
     KMode = 'Mode';
       KDegMode = 'DegMode';


{$R *.DFM}

Function TRPN_Form.ProcessEntry : boolean;
var
   k : integer;
   f : float;
begin
     Result := True;
     if Length(Entry.Text) = 0 then exit;
     val(Entry.Text,f,k);
     Stack.Push(f);
     Entry.Clear;
     Result := k = 0;
end;

Procedure TRPN_Form.RefreshView;
var
   i : integer;
   tw : integer;
   s,s1 : string;
   tm : TTextMetric;
   ofnt : HFont;
   ti : integer;
begin
     StkDisp.Items.BeginUpdate;
     StkDisp.Items.Clear;

     if Stack.Count = 0 then StkDisp.Items.Add('Empty Stack')
     else
     begin
          with StkDisp.Canvas do
          begin
               ofnt := SelectObject(Handle,StkDisp.Font.Handle);
               GetTextMetrics(Handle,tm);
               SelectObject(Handle,ofnt);
          end;
          tw := pred(StkDisp.Width div tm.tmAveCharWidth);
          if (StkDisp.Height div Stack.Count) < tm.tmHeight then  { tenir compte de la scrollbar ! }
             tw := pred((StkDisp.Width-GetSystemMetrics(sm_CxVScroll)) div tm.tmAveCharWidth);


          with StkDisp.Items do
          begin
               for i := Stack.Count downto 1 do
               begin
                    s := Format('%d: ',[i]);
                    str(tw-length(s),s1);
                    s := s+'%'+s1+'s';
                    Add(Format(s,[FloatToStr(Stack.Items[i])]));
               end;
          end;
     end;
     StkDisp.ItemIndex := StkDisp.Items.Count -1;
     ti := StkDisp.ItemIndex - (StkDisp.Height div StkDisp.ItemHeight) + 1;
     if ti < 0 then ti := 0;
     StkDisp.TopIndex := ti;

     StkDisp.Items.EndUpdate;
end;


procedure TRPN_Form.FormCreate(Sender: TObject);
var
   s : string;
begin
{     ClientWidth := Panel1.Width; }
     Book.PageIndex := 1;

     Application.OnMessage := MessageEvent; { !!! }
     Stack := TRPNStack.Create;
     Stack.Degmode := dmDegrees;
     _deg.Checked := True;

     if not FileExists(ChangeFileExt(ParamStr(0),'.INI')) then
     begin  { affiche le readme -- on utilisera ensuite les valeurs par dfaut }
          s := ChangeFileExt(ParamStr(0),'.TXT')+#0;
          ShellExecute(Self.Handle,nil,@s[1],nil,nil,sw_ShowMaximized);
          { que a marche ou pas, on continue }
     end;

     Ini := TIniFile.Create(ChangeFileExt(ParamStr(0),'.INI'));

     UnFolded := Ini.ReadBool(KState,KUnFolded,False); { ferme par dfaut }
     Left := Ini.ReadInteger(KState,KLeft,Left);
     Top := Ini.ReadInteger(KState,KTop,Top);

     if Ini.ReadBool(KState,KMinimized,False) then WindowState := wsMinimized
                                                 else WindowState := wsNormal;

     Case Ini.ReadInteger(KMode,KDegMode,0) of
        1 : begin
            Stack.DegMode := dmRadians;
            _Rad.Checked := True;
            _Deg.Checked := False;
            _Grad.Checked := False;
           end;
        2 : begin
            Stack.DegMode := dmGrades;
            _Rad.Checked := False;
            _Deg.Checked := False;
            _Grad.Checked := True;
           end;
        else begin
            Stack.DegMode := dmDegrees;
            _Rad.Checked := False;
            _Deg.Checked := True;
            _Grad.Checked := False;
           end;
     end;

     RefreshFolded;


     RefreshView;
end;

procedure TRPN_Form.FormClose(Sender: TObject; var Action: TCloseAction);
var
   dm : integer;
begin
     Ini.WriteBool(KState,KUnFolded,UnFolded);
     Ini.WriteInteger(KState,KLeft,Left);
     Ini.WriteInteger(KState,KTop,Top);

     Ini.WriteBool(KState,KMinimized,WindowState = wsMinimized);

     case Stack.DegMode of
{       dmDegrees : dm := 0; }
       dmRadians : dm := 1;
       dmGrades : dm := 2;
     else dm := 0;
     end;

     Ini.WriteInteger(KMode,KDegMode,dm);

     Stack.Free; Stack := Nil;
     Ini.Free; Ini := nil;
end;

Procedure TRPN_Form.RefreshFolded;
begin
     UnFold.Visible := not UnFolded;
     Fold.Visible := UnFolded;
     if UnFolded then Self.ClientWidth := Panel1.Width + Panel5.Width + Panel6.Width
                 else Self.ClientWidth := Panel1.Width;
end;

procedure TRPN_Form._EnterClick(Sender: TObject);
begin
     if Length(Entry.Text) = 0 then Stack.DUP
                               else ProcessEntry;
     RefreshView;
end;

procedure TRPN_Form._NumClick(Sender: TObject);
begin
     Entry.Text := Entry.Text+(Sender as TSpeedButton).Caption;
end;

procedure TRPN_Form._CClick(Sender: TObject);
begin
     Entry.Clear;
end;

procedure TRPN_Form._addClick(Sender: TObject);
begin
     if not ProcessEntry then exit;
     Stack.ADD;
     RefreshView;
end;

Procedure TRPN_Form.SimKey;
var
   btn : TSpeedButton;
begin
     btn := nil;
     case Char(Key) of
       '0' : btn := _0;
       '1' : btn := _1;
       '2' : btn := _2;
       '3' : btn := _3;
       '4' : btn := _4;
       '5' : btn := _5;
       '6' : btn := _6;
       '7' : btn := _7;
       '8' : btn := _8;
       '9' : btn := _9;
       '.' : btn := _dot;
       ' ' : btn := _spc;
       '+' : btn := _add;
       '-' : btn := _sub;
       '*' : btn := _mul;
       '/' : btn := _div;
       'e','E' : btn := _eex;
       #27 : btn := _C;
       #8  : btn := _drop;
     else
     begin
          case Key of
            vk_Right : btn := _SWP;
            vk_Left : btn := Pick;
          end;
     end;
     end;
     if Assigned(btn) then
     begin
          btn.OnClick(btn);
          {PostMessage(btn.Handle,wm_LButtonDown,0,MakeLong(4,4));
          PostMessage(btn.Handle,wm_LButtonUp,0,MakeLong(4,4));
          }
     end;
end;

procedure TRPN_Form.FormKeyPress(Sender: TObject; var Key: Char);
begin
     SimKey(False,word(Key));
end;

procedure TRPN_Form._subClick(Sender: TObject);
begin
     if not ProcessEntry then exit;
     Stack.SUB;
     RefreshView;
end;

procedure TRPN_Form._mulClick(Sender: TObject);
begin
     if not ProcessEntry then exit;
     Stack.MUL;
     RefreshView;
end;

procedure TRPN_Form._divClick(Sender: TObject);
begin
     if not ProcessEntry then exit;
     Stack.fDIV;
     RefreshView;
end;

procedure TRPN_Form._negClick(Sender: TObject);
begin
     if not ProcessEntry then exit;
     Stack.NEG;
     RefreshView;
end;

procedure TRPN_Form._eexClick(Sender: TObject);
begin
     if Length(Entry.Text) = 0 then
        Entry.Text := Entry.Text+'1';
     Entry.Text := Entry.Text+'E';
end;

procedure TRPN_Form._spcClick(Sender: TObject);
begin
     Entry.Text := Entry.Text+' ';
end;

procedure TRPN_Form._dropClick(Sender: TObject);
begin
     if Length(Entry.Text) > 0 then Entry.Text := copy (Entry.Text,1,length(Entry.Text)-1)
     else
     begin
          Stack.DROP;
          RefreshView;
     end;
end;

procedure TRPN_Form._negMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
     _Enter.SetFocus;
end;

procedure TRPN_Form._clearClick(Sender: TObject);
begin
     if Entry.Text <> '' then exit;
     Stack.CLR;
     RefreshView;
end;

procedure TRPN_Form._swpClick(Sender: TObject);
begin
     if Entry.Text <> '' then exit;
     Stack.SWAP;
     RefreshView;
end;

Procedure TRPN_Form.MessageEvent(var msg : TMSG; var Handled : boolean);
var
   Key : Word;
begin
     { ce dtournement sert  court-circuiter la gestion de focus faite par le
     dialog manager -- car ici, elle est nuisible... }

     if Entry.Focused then exit;

     case msg.Message of
       wm_KeyDown :
       begin
            Key := Msg.WParam;
            Case Key of
              vk_Down,
              vk_up : Handled := not StkDisp.Focused;

              vk_Left,
              vk_Right : Handled := True;
            end;
       end;
       wm_KeyUp :
       begin
            Key := Msg.WParam;
            Case Key of
              vk_Right,vk_left :
                begin
                     Handled := True;
                     SimKey(False,key);
                end;
              vk_up,
              vk_down : Handled := not StkDisp.Focused;
            end;
       end;
     end;
end;

procedure TRPN_Form.ListBox1DragDrop(Sender, Source: TObject; X,
  Y: Integer);
begin
     if Source = StkDisp then ListBox1.Items.Add(StkDisp.Items[StkDisp.ItemIndex]);
end;

procedure TRPN_Form.ListBox1DragOver(Sender, Source: TObject; X,
  Y: Integer; State: TDragState; var Accept: Boolean);
begin
     Accept := Source = StkDisp;
end;

procedure TRPN_Form.TabsChange(Sender: TObject; NewTab: Integer;
  var AllowChange: Boolean);
begin
     Book.PageIndex := Tabs.TabIndex;
end;

procedure TRPN_Form._2ndClick(Sender: TObject);
begin
{     _2nd.Down := not _2nd.Down; }
end;

procedure TRPN_Form._degClick(Sender: TObject);
begin
     Stack.DegMode := dmDegrees;
end;

procedure TRPN_Form._RadClick(Sender: TObject);
begin
     Stack.DegMode := dmRadians;
end;

procedure TRPN_Form._GradClick(Sender: TObject);
begin
     Stack.Degmode := dmGrades;
end;

procedure TRPN_Form._SINClick(Sender: TObject);
begin
     if not ProcessEntry then exit;
     if not _2nd.Down then Stack.SIN
     else
     begin
          Stack.ArcSin;
          _2nd.Down := False;
     end;
     RefreshView;
end;

procedure TRPN_Form._COSClick(Sender: TObject);
begin
     if not ProcessEntry then exit;
     if not _2nd.Down then Stack.COS
     else
     begin
          Stack.ArcCos;
          _2nd.Down := False;
     end;
     RefreshView;
end;

procedure TRPN_Form._TANClick(Sender: TObject);
begin
     if not ProcessEntry then exit;
     if not _2nd.Down then Stack.TAN
     else
     begin
          Stack.ArcTan;
          _2nd.Down := False;
     end;

     RefreshView;
end;

procedure TRPN_Form._TANHClick(Sender: TObject);
begin
     if not ProcessEntry then exit;
     if not _2nd.Down then Stack.TH
     else
     begin
          Stack.ArgTanH;
          _2nd.Down := False;
     end;
     RefreshView;
end;

procedure TRPN_Form._COSHClick(Sender: TObject);
begin
     if not ProcessEntry then exit;
     if not _2nd.Down then Stack.CH
     else
     begin
          Stack.ArgCosH;
          _2nd.Down := False;
     end;

     RefreshView;
end;

procedure TRPN_Form._SINHClick(Sender: TObject);
begin
     if not ProcessEntry then exit;
     if not _2nd.Down then Stack.SH
     else
     begin
          Stack.ArgSinH;
          _2nd.Down := False;
     end;

     RefreshView;
end;

procedure TRPN_Form._PIClick(Sender: TObject);
begin
     if not ProcessEntry then exit;
     Stack._pi;
     RefreshView;
end;

procedure TRPN_Form._SQxClick(Sender: TObject);
begin
     if not ProcessEntry then exit;
     Stack.sq;
     RefreshView;
end;

procedure TRPN_Form._YexpXClick(Sender: TObject);
begin
     if not ProcessEntry then exit;
     Stack.POWER;
     RefreshView;
end;

procedure TRPN_Form._EXPClick(Sender: TObject);
begin
     if not ProcessEntry then exit;
     Stack.exp;
     RefreshView;
end;

procedure TRPN_Form._E10Click(Sender: TObject);
begin
     if not ProcessEntry then exit;
     Stack.ALOG;
     RefreshView;
end;

procedure TRPN_Form._SQRTClick(Sender: TObject);
begin
     if not ProcessEntry then exit;
     Stack.sqrt;
     RefreshView;
end;

procedure TRPN_Form.SpeedButton8Click(Sender: TObject);
begin
     if not ProcessEntry then exit;
     Stack.xroot;
     RefreshView;
end;

procedure TRPN_Form._LNClick(Sender: TObject);
begin
     if not ProcessEntry then exit;
     Stack.ln;
     RefreshView;
end;

procedure TRPN_Form._LOGClick(Sender: TObject);
begin
     if not ProcessEntry then exit;
     Stack.LOG;
     RefreshView;
end;

procedure TRPN_Form._FACTClick(Sender: TObject);
begin
     if not ProcessEntry then exit;
     Stack.fact;
     RefreshView;
end;

procedure TRPN_Form._CombClick(Sender: TObject);
begin
     if not ProcessEntry then exit;
     Stack.comb;
     RefreshView;
end;

procedure TRPN_Form._ArrClick(Sender: TObject);
begin
     if not ProcessEntry then exit;
     Stack.perm;
     RefreshView;
end;

procedure TRPN_Form.FoldClick(Sender: TObject);
begin
     UnFolded := False;
     RefreshFolded;
end;

procedure TRPN_Form.UnFoldClick(Sender: TObject);
begin
     UnFolded := True;
     RefreshFolded;
end;

procedure TRPN_Form.ListBox1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
     if (Shift = []) and (Key = VK_DELETE)
        and (ListBox1.ItemIndex >= 0) then
          ListBox1.Items.Delete(ListBox1.ItemIndex);
end;

procedure TRPN_Form.Button3Click(Sender: TObject);
begin
     MessageDlg('RPN Calculator'#13#10+#13#10+
                'Just because I can''t bear CALC.EXE anymore'#13#10+#13#10+
                'Written by Cyrille Chplov'+#13#10+#13#10+
                'Version 0.9   Sept 11, 1995 - FREEWARE'+#13#10+
                'Contact : 100420.1574@compuserve.com',
                mtInformation,[mbOK],0);
end;

procedure TRPN_Form.PickClick(Sender: TObject);
var
   level : integer;
   f : float;
begin
     if StkDisp.ItemIndex < 0 then exit;
     if Stack.Count <= 0 then exit;

     level := Stack.Count - StkDisp.ItemIndex;
     f := Stack.Items[level];
     Stack.Delete(Level);
     Stack.Push(f);
     RefreshView;

     StkDisp.ItemIndex := Stack.Count - Level;
     with StkDisp do
          if ItemIndex < TopIndex then TopIndex := ItemIndex;
     
end;

end.
